#ifndef KTOOLBUTTON_H
#define KTOOLBUTTON_H

#include <QToolButton>
#include <QWidget>
#include <QEvent>
#include "gui_g.h"

namespace kdk
{

/** @defgroup 按钮模块
  * @{
  */

/**
 * @brief P2中目前只支持第一种
 */
enum KToolButtonType
{
    Flat,
    SemiFlat,
    Background
};

class KToolButtonPrivate;

/**
 * @brief KToolbutton
 */
class GUI_EXPORT KToolButton:public QToolButton
{
    Q_OBJECT

public:
    KToolButton(QWidget*parent);

    /**
     * @brief 返回类型
     * @return
     */
    KToolButtonType type();

    /**
     * @brief 设置类型
     * @param type
     */
    void setType(KToolButtonType type);

    /**
     * @brief 设置Icon
     * @param icon
     */
    void setIcon(const QIcon& icon);

    /**
     * @brief 设置正在加载状态
     * @param flag
     */
    void setLoading(bool flag);

    /**
     * @brief 返回是否正在加载
     * @return
     */
    bool isLoading();

    /**
     * @brief 获取Icon
     * @return
     */
    QIcon icon();

protected:
    bool eventFilter(QObject *watched, QEvent *event);

private:
    Q_DECLARE_PRIVATE(KToolButton)
    KToolButtonPrivate*const d_ptr;
};
}
/**
  * @example testtoolbutton/widget.h
  * @example testtoolbutton/widget.cpp
  * @}
  */
#endif // KTOOLBUTTON_H
